###############################################################################
# ChangeMood.pm                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $changemoodpmver = 'YaBB 2.7.00 $Revision: 0.3 $';

our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our (
    %FORM,   $iamguest, $uid,       $username, $showmoodicon,
    $NoMood, %moodlist, $modimgurl, $moodext
);

load_language('Mods/Mood');

if ($iamguest) { fatal_error('no_access'); }

sub changemood {
    $NoMood ||= q{};
    {
        no strict qw(refs);
        if (   ${ $uid . $username }{'mood'}
            && ${ $uid . $username }{'mood'} eq $NoMood )
        {
            $NoMood = 'NoMood';
        }
        else { $NoMood = ${ $uid . $username }{'mood'}; }
    }
    my @moodlist =
      sort { lc $moodlist{$a} cmp lc $moodlist{$b} } keys %moodlist;
    my $mood_out = q{};
    for (@moodlist) {
        my $sel = q{};
        if ( $NoMood eq $_ ) { $sel = ' selected="selected" '; }
        $mood_out .=
          qq~        <option value="$_"$sel>$moodlist{$_}</option>\n~;
    }
    our ( $mymood, $mymoodout, $mymoodcol1 );
    get_template('Mods/Mood');
    my $my_showmoodicon = q{};
    if ( $showmoodicon == 1 ) {
        $my_showmoodicon = q~
                            document.images.moodicons.title = mymoodt;~;
    }
    else {
        $my_showmoodicon = q~
                                moodtxt.textContent = mymoodt;
                            if ( mymood == "NoMood" ) {
                                moodspan.setAttribute("class", "bold");
                            }
                            else {
                                moodspan.setAttribute("class", "mood bold " + mymood);
                            }~;
    }
    my $moodicon =
qq~<span id='moodspan' class='mood bold $NoMood'><img src='$modimgurl/Mood/$NoMood$moodext' id='moodicons' alt='' /> <span id='moodtxt'>$moodlist{$NoMood}</span> </span>~;
    if ($showmoodicon) {
        $moodicon =
qq~<img src='$modimgurl/Mood/$NoMood$moodext' id='moodicons' title='$moodlist{$NoMood}' />~;
    }
    our $output = $mymood;
    $output =~ s/\Q{yabb moodicon}\E/$moodicon/gxsm;
    $output =~ s/\Q{yabb my_showmoodicon}\E/$my_showmoodicon/gxsm;
    $output =~ s/\Q{yabb mymoodout}\E/$mymoodout/gxsm;
    $output =~ s/\Q{yabb mymoodcol1}\E/$mymoodcol1/gxsm;
    $output =~ s/\Q{yabb moodext}\E/$moodext/gxsm;
    $output =~ s/\Q{yabb mood_out}\E/$mood_out/gxsm;

    print_output_header();
    print_html_output_and_finish();
    return;
}

sub changemood2 {

    if ( $iamguest || !$FORM{'mood'} ) { fatal_error('no_access'); }
    {
        no strict qw(refs);
        ${ $uid . $username }{'mood'} = $FORM{'mood'};
    }
    user_account( $username, 'update' );
    our ($mymood_2);
    get_template('Mods/Mood');
    our $output = $mymood_2;

    print_output_header();
    print_html_output_and_finish();
}

1;
